diff -u -r t/compat/failure.t ../perl.git/cpan/Test-Harness/t/compat/failure.t
--- t/compat/failure.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/compat/failure.t	2010-06-29 14:29:34.000000000 +0100
@@ -19,18 +19,8 @@
         return sub { $died = 1 }
     }
 
-    my $sample_tests;
-    if ( $ENV{PERL_CORE} ) {
-        my $updir = File::Spec->updir;
-        $sample_tests = File::Spec->catdir(
-            $updir, 'ext', 'Test-Harness', 't',
-            'sample-tests'
-        );
-    }
-    else {
-        my $curdir = File::Spec->curdir;
-        $sample_tests = File::Spec->catdir( $curdir, 't', 'sample-tests' );
-    }
+    my $curdir = File::Spec->curdir;
+    my $sample_tests = File::Spec->catdir( $curdir, 't', 'sample-tests' );
 
     {
         local $SIG{__DIE__} = prepare_for_death();
diff -u -r t/compat/inc_taint.t ../perl.git/cpan/Test-Harness/t/compat/inc_taint.t
--- t/compat/inc_taint.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/compat/inc_taint.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        use lib 't/lib';
-    }
+  use lib 't/lib';
 }
 
 use strict;
@@ -34,9 +28,7 @@
     select NULL;
     my ( $tot, $failed ) = Test::Harness::execute_tests(
         tests => [
-            $ENV{PERL_CORE}
-            ? '../ext/Test-Harness/t/sample-tests/inc_taint'
-            : 't/sample-tests/inc_taint'
+            't/sample-tests/inc_taint'
         ]
     );
     select STDOUT;
diff -u -r t/compat/test-harness-compat.t ../perl.git/cpan/Test-Harness/t/compat/test-harness-compat.t
--- t/compat/test-harness-compat.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/compat/test-harness-compat.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = '../lib';
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -22,7 +16,7 @@
 local $ENV{HARNESS_PERL_SWITCHES};
 
 my $TEST_DIR
-  = $ENV{PERL_CORE} ? '../ext/Test-Harness/t/sample-tests' : 't/sample-tests';
+  = 't/sample-tests';
 
 {
 
diff -u -r t/file.t ../perl.git/cpan/Test-Harness/t/file.t
--- t/file.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/file.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -19,9 +13,9 @@
 my $HARNESS = 'TAP::Harness';
 
 my $source_tests
-  = $ENV{PERL_CORE} ? '../ext/Test-Harness/t/source_tests' : 't/source_tests';
+  = 't/source_tests';
 my $sample_tests
-  = $ENV{PERL_CORE} ? '../ext/Test-Harness/t/sample-tests' : 't/sample-tests';
+  = 't/sample-tests';
 
 plan tests => 56;
 
diff -u -r t/grammar.t ../perl.git/cpan/Test-Harness/t/grammar.t
--- t/grammar.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/grammar.t	2010-06-29 14:29:34.000000000 +0100
@@ -3,13 +3,7 @@
 use strict;
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use Test::More tests => 94;
diff -u -r t/harness-bailout.t ../perl.git/cpan/Test-Harness/t/harness-bailout.t
--- t/harness-bailout.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/harness-bailout.t	2010-06-29 14:29:34.000000000 +0100
@@ -35,10 +35,6 @@
 
         $harness->runtests(
             File::Spec->catfile(
-                (   $ENV{PERL_CORE}
-                    ? ( File::Spec->updir, 'ext', 'Test-Harness' )
-                    : ()
-                ),
                 't',
                 'sample-tests',
                 'bailout'
diff -u -r t/harness-subclass.t ../perl.git/cpan/Test-Harness/t/harness-subclass.t
--- t/harness-subclass.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/harness-subclass.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -53,10 +47,6 @@
 
     my $aggregate = $harness->runtests(
         File::Spec->catfile(
-            (   $ENV{PERL_CORE}
-                ? ( File::Spec->updir, 'ext', 'Test-Harness' )
-                : ()
-            ),
             't',
             'sample-tests',
             'simple'
diff -u -r t/harness.t ../perl.git/cpan/Test-Harness/t/harness.t
--- t/harness.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/harness.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+   unshift @INC, 't/lib';
 }
 
 use strict;
@@ -20,9 +14,9 @@
 my $HARNESS = 'TAP::Harness';
 
 my $source_tests
-  = $ENV{PERL_CORE} ? '../ext/Test-Harness/t/source_tests' : 't/source_tests';
+  = 't/source_tests';
 my $sample_tests
-  = $ENV{PERL_CORE} ? '../ext/Test-Harness/t/sample-tests' : 't/sample-tests';
+  = 't/sample-tests';
 
 plan tests => 128;
 
@@ -545,9 +539,7 @@
     eval {
         _runtests(
             $harness,
-            $ENV{PERL_CORE}
-            ? '../ext/Test-Harness/t/data/catme.1'
-            : 't/data/catme.1'
+            't/data/catme.1'
         );
     };
 
@@ -595,9 +587,7 @@
             exec      => sub {
                 return [
                     $cat,
-                    $ENV{PERL_CORE}
-                    ? '../ext/Test-Harness/t/data/catme.1'
-                    : 't/data/catme.1'
+                    't/data/catme.1'
                 ];
             },
         }
@@ -645,9 +635,7 @@
             stdout    => $capture,
             exec      => sub {
                 open my $fh,
-                  $ENV{PERL_CORE}
-                  ? '../ext/Test-Harness/t/data/catme.1'
-                  : 't/data/catme.1';
+                  't/data/catme.1';
                 return $fh;
             },
         }
@@ -978,11 +966,7 @@
     # coverage tests for the basically untested T::H::_open_spool
 
     my @spool = (
-        (   $ENV{PERL_CORE}
-            ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-            : ()
-        ),
-        ( 't', 'spool' )
+        't', 'spool'
     );
     $ENV{PERL_TEST_HARNESS_DUMP_TAP} = File::Spec->catfile(@spool);
 
diff -u -r t/iterator_factory.t ../perl.git/cpan/Test-Harness/t/iterator_factory.t
--- t/iterator_factory.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/iterator_factory.t	2010-06-29 14:29:34.000000000 +0100
@@ -4,13 +4,7 @@
 ##
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -77,10 +71,6 @@
 use_ok('TAP::Parser::SourceHandler::Handle');
 
 my $test_dir = File::Spec->catdir(
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'source_tests'
 );
diff -u -r t/iterators.t ../perl.git/cpan/Test-Harness/t/iterators.t
--- t/iterators.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/iterators.t	2010-06-29 14:29:34.000000000 +0100
@@ -42,10 +42,6 @@
             command => [
                 $^X,
                 File::Spec->catfile(
-                    (   $ENV{PERL_CORE}
-                        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-                        : ()
-                    ),
                     't',
                     'sample-tests',
                     'out_err_mix'
diff -u -r t/lib/MyShebangger.pm ../perl.git/cpan/Test-Harness/t/lib/MyShebangger.pm
--- t/lib/MyShebangger.pm	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/lib/MyShebangger.pm	2010-06-29 16:10:01.000000000 +0100
@@ -40,7 +40,10 @@
     die "$file_in is not perl"
       unless $cmd =~ m{^perl(?:\z|[^a-z])};
 
-    if ( $Config{startperl} =~ m,^\#!.*/perl, ) {
+    if ($ENV{PERL_CORE}) {
+        $interpreter = $^X;
+    }
+    elsif ( $Config{startperl} =~ m,^\#!.*/perl, ) {
         $interpreter = $Config{startperl};
         $interpreter =~ s,^\#!,,;
     }
Only in t/lib: Test
Only in t/lib: if.pm
diff -u -r t/multiplexer.t ../perl.git/cpan/Test-Harness/t/multiplexer.t
--- t/multiplexer.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/multiplexer.t	2010-06-29 14:29:34.000000000 +0100
@@ -56,11 +56,6 @@
             return [
                 TAP::Parser->new(
                     {   source => File::Spec->catfile(
-                            (   $ENV{PERL_CORE}
-                                ? ( File::Spec->updir(), 'ext', 'Test-Harness'
-                                  )
-                                : ()
-                            ),
                             't',
                             'sample-tests',
                             'simple'
@@ -82,12 +77,6 @@
             return map {
                 [   TAP::Parser->new(
                         {   source => File::Spec->catfile(
-                                (   $ENV{PERL_CORE}
-                                    ? ( File::Spec->updir(), 'ext',
-                                        'Test-Harness'
-                                      )
-                                    : ()
-                                ),
                                 't',
                                 'sample-tests',
                                 'simple'
@@ -129,12 +118,6 @@
               ( map {
                     [   TAP::Parser->new(
                             {   source => File::Spec->catfile(
-                                    (   $ENV{PERL_CORE}
-                                        ? ( File::Spec->updir(), 'ext',
-                                            'Test-Harness'
-                                          )
-                                        : ()
-                                    ),
                                     't',
                                     'sample-tests',
                                     'simple'
diff -u -r t/nofork-mux.t ../perl.git/cpan/Test-Harness/t/nofork-mux.t
--- t/nofork-mux.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/nofork-mux.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,17 +1,11 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        use lib 't/lib';
-    }
+  use lib 't/lib';
 }
 
 use strict;
 
 use NoFork;
 require(
-    ( $ENV{PERL_CORE} ? '../ext/Test-Harness/' : '' ) . 't/multiplexer.t' );
+    't/multiplexer.t' );
diff -u -r t/nofork.t ../perl.git/cpan/Test-Harness/t/nofork.t
--- t/nofork.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/nofork.t	2010-06-29 14:29:34.000000000 +0100
@@ -4,13 +4,7 @@
 # NOTE maybe a good candidate for xt/author or something.
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        use lib 't/lib';
-    }
+  use lib 't/lib';
 }
 
 use strict;
@@ -57,8 +51,8 @@
             stdout    => $capture,
         }
     );
-    $harness->runtests( ( $ENV{PERL_CORE} ? '../ext/Test-Harness/' : '' )
-        . 't/sample-tests/simple' );
+    $harness->runtests( 
+        't/sample-tests/simple' );
     my @output = tied($$capture)->dump;
     is pop @output, "Result: PASS\n", 'status OK';
     pop @output;    # get rid of summary line
diff -u -r t/parse.t ../perl.git/cpan/Test-Harness/t/parse.t
--- t/parse.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/parse.t	2010-06-29 14:29:34.000000000 +0100
@@ -3,13 +3,7 @@
 use strict;
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        use lib 't/lib';
-    }
+  use lib 't/lib';
 }
 
 use Test::More tests => 294;
@@ -453,9 +447,8 @@
 
 # Check source => $filehandle
 can_ok $PARSER, 'new';
-open my $fh, $ENV{PERL_CORE}
-  ? '../ext/Test-Harness/t/data/catme.1'
-  : 't/data/catme.1';
+open my $fh,
+  't/data/catme.1';
 $parser = $PARSER->new( { source => $fh } );
 isa_ok $parser, $PARSER, '... and calling it should succeed';
 ok @results = _get_results($parser), 'The parser should return results';
@@ -632,10 +625,6 @@
 
     my $parser = TAP::Parser->new(
         {   source => File::Spec->catfile(
-                (   $ENV{PERL_CORE}
-                    ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-                    : ()
-                ),
                 't',
                 'sample-tests',
                 'simple'
diff -u -r t/parser-config.t ../perl.git/cpan/Test-Harness/t/parser-config.t
--- t/parser-config.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/parser-config.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -20,7 +14,7 @@
 use_ok('MyGrammar');
 use_ok('MyResultFactory');
 
-my @t_path = $ENV{PERL_CORE} ? ( updir(), 'ext', 'Test-Harness' ) : ();
+my @t_path = ();
 my $source = catfile( @t_path, 't', 'source_tests', 'source' );
 my %customize = (
     grammar_class        => 'MyGrammar',
diff -u -r t/parser-subclass.t ../perl.git/cpan/Test-Harness/t/parser-subclass.t
--- t/parser-subclass.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/parser-subclass.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -19,7 +13,7 @@
 use_ok('TAP::Parser::SubclassTest');
 
 # TODO: for my $source ( ... ) ?
-my @t_path = $ENV{PERL_CORE} ? ( updir(), 'ext', 'Test-Harness' ) : ();
+my @t_path = ();
 
 {    # perl source
     %INIT = %CUSTOM = ();
diff -u -r t/perl5lib.t ../perl.git/cpan/Test-Harness/t/perl5lib.t
--- t/perl5lib.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/perl5lib.t	2010-06-29 14:29:34.000000000 +0100
@@ -31,7 +31,7 @@
 # Change PERL5LIB so we ensure it's preserved.
 $ENV{PERL5LIB} = join(
     $path_sep, 'wibble',
-    ( $ENV{PERL_CORE} ? '../lib' : () ), $ENV{PERL5LIB} || ''
+    $ENV{PERL5LIB} || ''
 );
 
 open TEST, ">perl5lib_check.t.tmp";
diff -u -r t/process.t ../perl.git/cpan/Test-Harness/t/process.t
--- t/process.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/process.t	2010-06-29 14:29:34.000000000 +0100
@@ -28,10 +28,6 @@
 );
 
 my $source = File::Spec->catfile(
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'sample-tests',
     'delayed'
diff -u -r t/prove.t ../perl.git/cpan/Test-Harness/t/prove.t
--- t/prove.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/prove.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -1017,9 +1011,7 @@
             args => {
                 argv => [qw( one two three )],
             },
-            proverc => $ENV{PERL_CORE}
-            ? '../ext/Test-Harness/t/proverc/emptyexec'
-            : 't/proverc/emptyexec',
+            proverc => 't/proverc/emptyexec',
             switches => [$dummy_test],
             expect   => { exec => '' },
             runlog   => [
diff -u -r t/proverc.t ../perl.git/cpan/Test-Harness/t/proverc.t
--- t/proverc.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/proverc.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', 'lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -20,10 +14,6 @@
 
 $prove->add_rc_file(
     File::Spec->catfile(
-        (   $ENV{PERL_CORE}
-            ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-            : ()
-        ),
         't', 'data',
         'proverc'
     )
diff -u -r t/proverun.t ../perl.git/cpan/Test-Harness/t/proverun.t
--- t/proverun.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/proverun.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', 'lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -19,10 +13,6 @@
 
 BEGIN {
     my $t_dir = File::Spec->catdir(
-        (   $ENV{PERL_CORE}
-            ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-            : ()
-        ),
         't'
     );
 
diff -u -r t/regression.t ../perl.git/cpan/Test-Harness/t/regression.t
--- t/regression.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/regression.t	2010-06-29 16:10:01.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = '../lib';
-    }
-    else {
-        push @INC, 't/lib';
-    }
+  push @INC, 't/lib';
 }
 
 use strict;
@@ -30,10 +24,6 @@
 
 my $SAMPLE_TESTS = File::Spec->catdir(
     File::Spec->curdir,
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'sample-tests'
 );
diff -u -r t/sample-tests/delayed ../perl.git/cpan/Test-Harness/t/sample-tests/delayed
--- t/sample-tests/delayed	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/sample-tests/delayed	2010-06-29 14:29:34.000000000 +0100
@@ -1,10 +1,4 @@
 # Used to test Process.pm
-BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        @INC = '../lib';
-    }
-}
-
 use Time::HiRes qw(sleep);
 
 my $delay = 0.01;
diff -u -r t/source.t ../perl.git/cpan/Test-Harness/t/source.t
--- t/source.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/source.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -16,10 +10,6 @@
 use File::Spec;
 
 my $dir = File::Spec->catdir(
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'source_tests'
 );
diff -u -r t/source_handler.t ../perl.git/cpan/Test-Harness/t/source_handler.t
--- t/source_handler.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/source_handler.t	2010-06-29 16:10:01.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', '../ext/Test-Harness/t/lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+   unshift @INC, 't/lib';
 }
 
 use strict;
@@ -27,10 +21,6 @@
 my $HAS_ECHO = -x '/bin/echo';
 
 my $dir = File::Spec->catdir(
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'source_tests'
 );
@@ -94,7 +84,7 @@
         ],
         make_iterator => [
             {   name   => "valid executable",
-                raw    => [ $perl, '-It/lib', '-T', $file{source} ],
+                raw    => [ $perl, '-I../../lib', '-It/lib', '-T', $file{source} ],
                 iclass => 'TAP::Parser::Iterator::Process',
                 output        => [ '1..1', 'ok 1 - source' ],
                 assemble_meta => 1,
diff -u -r t/source_tests/source ../perl.git/cpan/Test-Harness/t/source_tests/source
--- t/source_tests/source	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/source_tests/source	2010-06-29 16:10:01.000000000 +0100
@@ -1,13 +1,8 @@
 #!/usr/bin/perl -wT
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', 'lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
+  unshift @INC, '../../lib' if $ENV{PERL_CORE};
 }
 
 use Test::More tests => 1;
diff -u -r t/spool.t ../perl.git/cpan/Test-Harness/t/spool.t
--- t/spool.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/spool.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', 'lib' );
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 # test T::H::_open_spool and _close_spool - these are good examples
@@ -67,7 +61,7 @@
 
     # coverage tests for the basically untested T::H::_open_spool
 
-    my @spool = ( $ENV{PERL_CORE} ? ('spool') : ( 't', 'spool' ) );
+    my @spool = ( 't', 'spool' );
     $ENV{PERL_TEST_HARNESS_DUMP_TAP} = File::Spec->catfile(@spool);
 
 # now given that we're going to be writing stuff to the file system, make sure we have
diff -u -r t/state.t ../perl.git/cpan/Test-Harness/t/state.t
--- t/state.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/state.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = '../lib';
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
@@ -16,7 +10,7 @@
 use App::Prove::State::Result;
 
 sub mn {
-    my $pfx = $ENV{PERL_CORE} ? '../ext/Test-Harness/' : '';
+    my $pfx = '';
     return map {"$pfx$_"} @_;
 }
 
diff -u -r t/state_results.t ../perl.git/cpan/Test-Harness/t/state_results.t
--- t/state_results.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/state_results.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = '../lib';
-    }
-    else {
-        unshift @INC, 't/lib';
-    }
+  unshift @INC, 't/lib';
 }
 
 use strict;
diff -u -r t/taint.t ../perl.git/cpan/Test-Harness/t/taint.t
--- t/taint.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/taint.t	2010-06-29 16:10:01.000000000 +0100
@@ -1,13 +1,7 @@
 #!/usr/bin/perl -w
 
 BEGIN {
-    if ( $ENV{PERL_CORE} ) {
-        chdir 't';
-        @INC = ( '../lib', 'lib' );
-    }
-    else {
         unshift @INC, 't/lib';
-    }
 }
 
 # Test that options in PERL5OPT are propogated to tainted tests
@@ -43,7 +37,7 @@
 }
 
 {
-    local $ENV{PERL5OPT} = $ENV{PERL_CORE} ? '-I../lib -Mstrict' : '-Mstrict';
+    local $ENV{PERL5OPT} = $ENV{PERL_CORE} ? '-I../../lib -Mstrict' : '-Mstrict';
     run_test_file(<<'END');
 #!/usr/bin/perl -T
 
diff -u -r t/testargs.t ../perl.git/cpan/Test-Harness/t/testargs.t
--- t/testargs.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/testargs.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,9 +1,5 @@
 #!/usr/bin/perl -w
 
-BEGIN {
-    chdir 't' and @INC = '../lib' if $ENV{PERL_CORE};
-}
-
 use strict;
 use lib 't/lib';
 
@@ -14,10 +10,6 @@
 use App::Prove;
 
 my $test = File::Spec->catfile(
-    (   $ENV{PERL_CORE}
-        ? ( File::Spec->updir(), 'ext', 'Test-Harness' )
-        : ()
-    ),
     't',
     'sample-tests',
     'echo'
diff -u -r t/utils.t ../perl.git/cpan/Test-Harness/t/utils.t
--- t/utils.t	2010-01-30 12:24:55.000000000 +0000
+++ ../perl.git/cpan/Test-Harness/t/utils.t	2010-06-29 14:29:34.000000000 +0100
@@ -1,9 +1,5 @@
 #!/usr/bin/perl -w
 
-BEGIN {
-    chdir 't' and @INC = '../lib' if $ENV{PERL_CORE};
-}
-
 use strict;
 use lib 't/lib';
 
